/*Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-EPD027-2R
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Works with Arduino DUE,Arduino mega2560,Arduino UNO Board
****************************************************/
#include "ER-EPD027-2.h"
#include "GUI_Paint.h"
#include "EPD_SDCard.h"
#include "ImageData.h"
#include <Wire.h>
#include <SPI.h>
#include <SD.h>
 
void setup()
{
    GUIPAINT paint;
    EPD2IN7B epd;
    EPD_SDCARD SD;

    if(epd.EPD_Init() != 0) {
        Serial.print("e-Paper init failed");
        return;
    }
    epd.EPD_Clear();
    // epd.EPD_Display();
    Serial.print("2.7inch e-Paper B demo\n");

#if 1
    /*show sd card pic*/
    //1.Initialize the SD card
    SD.SDCard_Init();

    //2.Create a new image cache named IMAGE_BW and fill it with white
    //Draw black image
    Serial.print("IMAGE_BW\n");
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    //3.Read BMP images into RAM
    SD.SDCard_ReadBMP("027-1rb1.bmp", 0, 0);

    //Draw red image
    Serial.print("IMAGE_BWR\n");
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    SD.SDCard_ReadBMP("027-1rr1.bmp", 0, 0);

    //4.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
    
     Serial.print("IMAGE_BW\n");
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    //3.Read BMP images into RAM
    SD.SDCard_ReadBMP("027-1rb2.bmp", 0, 0);

    //Draw red image
    Serial.print("IMAGE_BWR\n");
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    SD.SDCard_ReadBMP("027-1rr2.bmp", 0, 0);

    //4.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);   
    
 #endif   
//#elif 1    
#if 1
    //show image for array
    //1.Draw black image
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_DrawBitMap(IMAGE_BLACK);

    //2.Draw red image
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_DrawBitMap(IMAGE_RED);

    //3.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
    
#endif

#if 0
    /*Horizontal screen*/
    //1.Draw black image
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_270, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    paint.Paint_DrawPoint(5, 70, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(5, 80, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
    paint.Paint_DrawLine(20, 70, 50, 100, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(50, 70, 20, 100, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawRectangle(60, 70, 90, 100, BLACK, DRAW_FILL_FULL, DOT_PIXEL_1X1);
    paint.Paint_DrawCircle(125, 85, 15, BLACK, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawString_EN(5, 15, "hello world", &Font12, WHITE, BLACK);
    paint.Paint_DrawNum(5, 30, 123456789, &Font16, BLACK, WHITE);

    //2.Draw red image
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_270, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    paint.Paint_DrawPoint(5, 90, RED, DOT_PIXEL_3X3, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(5, 100, RED, DOT_PIXEL_4X4, DOT_STYLE_DFT);
    paint.Paint_DrawLine(125, 70, 125, 100, RED, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(110, 85, 140, 85, RED, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawRectangle(20, 70, 50, 100, RED, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawCircle(165, 85, 15, RED, DRAW_FILL_FULL, DOT_PIXEL_1X1);
    paint.Paint_DrawString_EN(5, 2, "www.buydisplay.com", &Font12, BLACK, WHITE);
    paint.Paint_DrawNum(5, 50, 987654321, &Font16, WHITE, RED);

    //3.Refresh the image in RAM to e-Paper
    epd.EPD_Display();

#endif

  Dev->Dev_Delay_ms(15000);
   epd.EPD_Clear();
     epd.EPD_TurnOnDisplay(); 

    epd.EPD_Sleep();


}

void loop()
{

}
